pro imc,dir,ic1,ic2,ic3,minim,maxim,rmax,str1,lum,d,ng1,ng2,ng3,inc

filei=['/e_1.14um_I_'+inc+'.dat','/e_1.61um_I_'+inc+'.dat',$
'/e_2.08um_I_'+inc+'.dat','/e_3.60um_I_'+inc+'.dat','/e_4.50um_I_'+inc+'.dat',$
'/e_5.'+inc+'um_I_'+inc+'.dat','/e_8.00um_I_'+inc+'.dat',$
'/e_24.0um_I_'+inc+'.dat','/e_70.0um_I_'+inc+'.dat',$
'/e_160.um_I_'+inc+'.dat']

;wavelength in cm
lam=[1.14, 1.61, 2.08, 3.6, 4.5, 5.8, 8.0, 24., 70., 160.]*1.e-4
lammu=[1.14, 1.61, 2.08, 3.6, 4.5, 5.8, 8.0, 24., 70., 160.]

nx=149
;select files
;read in images
file1=dir+filei(ic1)
readdat,file1,nx,im1
if ic2 eq 45 then begin
  file2=dir+filei(4)
  file4=dir+filei(5)
  readdat,file2,nx,im2
  readdat,file4,nx,im4
  im2=0.5*(im2+im4)
endif else begin
  file2=dir+filei(ic2)
  readdat,file2,nx,im2
endelse
file3=dir+filei(ic3)
readdat,file3,nx,im3


if ng1 gt 0 then begin
  makegauss,ng1,img1
  im1=convol(im1,img1,/edge_truncate)
endif
if ng2 gt 0 then begin
  makegauss,ng2,img2
  im2=convol(im2,img2,/edge_truncate)
endif
if ng3 gt 0 then begin
  makegauss,ng3,img3
  im3=convol(im3,img3,/edge_truncate)
endif

;normalize to distance
;d=2000.
pc=3.0857d18
lsun=3.845d33
;lum=lum*lsun
fnorm=lsun/pc*lum/pc/d^2/(4.*!pi)
;fnorm=lum/(4.*!pi)/d^2/pc/pc
print,'fnorm',fnorm
;flux is in ergs/cm^2/Hz/s
c=2.9979e10
;convert to Jy
fnorm1=fnorm*1.e23
fnorm2=fnorm*1.e23
fnorm3=fnorm*1.e23

print,'max images before norm',max(im1),max(im2),max(im3)
im1=im1*fnorm1
im2=im2*fnorm2
im3=im3*fnorm3
print,'max images after norm',max(im1),max(im2),max(im3)
;compare to interpolation of sed
;readcol,dir+'/efinites.dat',x5,f5,skipline=3+100*2,numline=100
;f5=f5*fnorm*1.e23/2.9979e14*x5
;fnew=interpol(f5,x5,lammu)
;print,'interpolate sed',fnew(ic1),fnew(ic2),fnew(ic3)

;okay, this is Jy/pixel.  should convert to something independent of 
;pixel size.  favorite units seem to be MJy/Sr
;first compute pixel size, assuming d=140 pc, rmaxi=5000 AU.
rmaxi=rmax
pixsize=2.*rmaxi/float(nx)/d
;that's in arcsec, need to square it
;also, convert to MJy (mega...), so divide by 10^6
;there are 206,265^2 square " per steradian
fact=1./pixsize^2/1.e6*(206265.)^2
print,'fact,pixsize',fact,pixsize
im1=im1*fact
im2=im2*fact
im3=im3*fact

print,'max images',alog10(max(im1)),alog10(max(im2)),alog10(max(im3))
if alog10(max(im1)) gt maxim then print,'saturation', alog10(max(im1)),maxim
if alog10(max(im2)) gt maxim then print,'saturation', alog10(max(im2)),maxim
if alog10(max(im3)) gt maxim then print,'saturation', alog10(max(im3)),maxim
print,''
;read in minim, maxim
imnew1=bytscl(alog10(im1),min=minim,max=maxim)
imnew2=bytscl(alog10(im2),min=minim,max=maxim)
imnew3=bytscl(alog10(im3),min=minim,max=maxim)

a=where(imnew1 gt 255,count)
if count gt 0 then imnew1(a)=255
a=where(imnew2 gt 255,count)
if count gt 0 then imnew2(a)=255
a=where(imnew3 gt 255,count)
if count gt 0 then imnew3(a)=255

half=fix(nx/2)
x=pixsize*(findgen(nx)-half)
y=x
;convert to pc
;x=x/206265.
;y=x
;xmax=rmax/206265.
xmax=rmax

;okay, plot images & contours

;plotting with nodata option to make box and get info for px,py
contour,imnew1,x,y,xrange=[-xmax,xmax],yrange=[-xmax,xmax],$
xticks=4,yticks=4,$
xstyle=1,ystyle=1,$
title=str1,$
charsize=1.3,charthick=2,xmargin=[7,3],ymargin=[3,2],$
xminor=4,yminor=4,xthick=1,ythick=1,/nodata

; Get size of plot window in device pixels.  (got this from an IDL help file)
PX = !X.WINDOW * !D.X_VSIZE
PY = !Y.WINDOW * !D.Y_VSIZE
; Desired size of image in pixels.
SX = PX[1] - PX[0] + 1
SY = PY[1] - PY[0] + 1
;print,sx,sy

sxnew=sx
synew=sy

tv,[[[imnew3]],[[imnew2]],[[imnew1]]],px[0],py[0],xsize=sxnew,ysize=synew,$
	true=3

;levarr=maxim*10^(-3.*findgen(2))
;levarr=reverse(levarr)
;print,levarr
;redo contour over images to get boxes in case they overlap with images
;but use /nodata since contours are meaningless in 3-color
contour,im1,x,y,/overplot,/nodata

end
