pro sed,dirm,nfreq,nincin,rstar,tstar,lumin,intit,d,nap,$
        Jy,atfilein,Av,flux,cs

loadct,10
ibar=0

ninc=nincin
atfile=atfilein
;mstar=mstarin
;mdot=mdotin
lum=lumin

;calculate fnorm
;fnorm=L/(4*pi*d^2)=(4*pi*R^2*sigma*T^4)/(4*pi*d^2)=(R^2*sigma*T^4)/d^2
;using model or specific input
c=2.9979e14
sigma=5.67e-5
pc=3.0857e18
lsun=3.845e33
;uncomment and comment next 2 lines out to calculate lum from rstar and tstar
lumstar=4.*!pi*(rstar*6.955e10)^2*sigma*tstar^2*tstar^2
lum=lum*lsun
;calculate accretion disk luminosity
;gn=6.6732d-8
;msol=1.989d33
;rsol=6.96d10
;mdot=mdot*msol/3.15576d7
;lacc=0.5*gn*msol/rsol*mstar/rstar*mdot 
;lum=lumstar+lacc
print,'stellar luminosity ',lumstar/lsun
;print,'accretion luminosity ',lacc/lsun
print,'total lum',lum/lsun
;print,mstar,mdot,msol 
fnorm=lum/(4.*!pi)/d^2/pc/pc
print,'fnorm',fnorm

;atfile='../models/parfiles/'+atfile
;read in kurucz stellar spectrum used as input for comparison
readcol,atfile,lama,junk,hnu,skipline=3
; convert from nm
lama=lama*1.e-3
nuhnu=hnu/lama*2.9979e14
;f=hnu*rstar^2/(4*pi*d^2)
;solve for rstar using lum (in case we want to use lum=1lsun)
rstar2=lumstar/(4.*!pi*sigma)/tstar^2/tstar^2
nuhnu=4.*!pi*nuhnu*rstar2/d/d/pc/pc
print,'kurucz peak',max(nuhnu)
print,size(nuhnu)
;print,'calculated rstar ',sqrt(rstar2)/6.96e10

;read in model, skip to aperture
readcol,dirm+'/flux.dat',x4,f4,skipline=nap*nfreq*ninc+1,numline=nfreq*ninc
readcol,dirm+'/sflux.dat',x4s,f4s,skipline=nap*nfreq*ninc+1,numline=nfreq*ninc
readcol,dirm+'/dflux.dat',x4d,f4d,skipline=0,numline=nfreq*ninc
x4t=x4
f4t=f4
;read in peeled spectrum
;readcol,dirm+'/eflux.dat',x5,f5,skipline=3+nfreq*(nap),numline=nfreq

;integrate fnu*dnu=flam*dlam=(lam*flam)*d(ln(lam))
sum=0.
for ii=0,ninc-1 do begin
  n1=ii*nfreq
  n2=n1+nfreq-1
  x4hi=x4(n1:n2)
  f4hi=f4(n1:n2)
  x4hi=alog(x4hi*1.e-4)
  result=int_tabulated(x4hi,f4hi,/sort)
; end points are only half as big
  if ii eq 0 or ii eq ninc-1 then result=result/2.
  sum=sum+result
endfor
print,'integral over all angles',sum/(ninc-1)
x4hi=x4(0:nfreq-1)
f4hi=f4(0:nfreq-1)
x4hi=alog(x4hi*1.e-4)
result=int_tabulated(x4hi,f4hi,/sort)
print,'edge-on result, integrating lam*flam*dloglam',result
x4hi=x4(0:nfreq-1)
f4hi=f4(0:nfreq-1)/x4hi
result=int_tabulated(x4hi,f4hi,/sort)
print,'edge-on result, integrating flam*dlam',result
  
;add in reddening
xnunew=x4(0:nfreq-1)
readcol,'../models/parfiles/kmh.par',klam,junk1,junk2,kkap
;interpolate onto flux grid
kapnew=interpol(kkap,klam,xnunew)
kapv=interpol(kkap,klam,0.55)
taul=kapnew/kapv/1.086*Av
extinct=exp(-taul)
for ii=0,ninc-1 do begin
; subtract direct and scattered spectrum (to get thermal only)
  f4t(nfreq*ii:nfreq*ii+nfreq-1)=f4(nfreq*ii:nfreq*ii+nfreq-1)-$
     f4s(nfreq*ii:nfreq*ii+nfreq-1)-f4d(nfreq*ii:nfreq*ii+nfreq-1)
  f4(nfreq*ii:nfreq*ii+nfreq-1)=f4(nfreq*ii:nfreq*ii+nfreq-1)*extinct
  f4s(nfreq*ii:nfreq*ii+nfreq-1)=f4s(nfreq*ii:nfreq*ii+nfreq-1)*extinct
  f4d(nfreq*ii:nfreq*ii+nfreq-1)=f4d(nfreq*ii:nfreq*ii+nfreq-1)*extinct
  f4t(nfreq*ii:nfreq*ii+nfreq-1)=f4t(nfreq*ii:nfreq*ii+nfreq-1)*extinct
endfor

if flux eq 't' then f4=f4t
if flux eq 'd' then f4=f4d
if flux eq 's' then f4=f4s

f4=f4*fnorm
;f5=f5*fnorm

;convert nuhnu and f4 to Jy; units are currently in lamflam=nufnu (erg...)
;first, divide by frequency to get erg/cm2/s/hz
;fnu=lamflam/nu
;c is in microns/s
;x4 is in microns
if Jy eq 1 then begin
  f4=f4/c*x4
;  f5=f5/c*x5
  nuhnu=nuhnu/c*lama
  ;now convert to Jy
  f4=f4*1.e23
;  f5=f5*1.e23
  nuhnu=nuhnu*1.e23
endif

maxm=max(f4)*3.
minm=maxm*1.e-5
print,'max',max(f4)

if jy eq 1 then begin
  ytit='Flux Density (Jy)'
endif else begin
  ytit='!4k!3F!d!4k!3!n (ergs s!u-1!n cm!u-2!n)'
endelse

ii=ninc-1
!psym=0
cmax=240
cmin=10
plot,(x4(0:nfreq-1)),0.*(f4(nfreq*ii:nfreq*ii+nfreq-1)),$
/xlog,/ylog,$
yrange=[minm,maxm],$
xrange=[0.2,1500.],$
xmargin=[10,3],charthick=2,$
xstyle=1,ystyle=1,title=intit,$
linestyle=0,ytitle=ytit,$
xtitle='!4k!3(!4l!3m)',charsize=cs,thick=2
oplot,lama,nuhnu,linestyle=1
for ii=0,ninc-1,1 do begin
ccol=(cmax-cmin)/11*ii+cmin
!psym=0
;don't plot first frequency since it includes all flux in this and
;shortward.
oplot,(x4(0:nfreq-2)),(f4(nfreq*ii:nfreq*ii+nfreq-2)),linestyle=0,color=ccol,$
 thick=2
endfor
;oplot,x5,f5,thick=5

if ibar eq 1 then begin
A = FINDGEN(17) * (!PI*2/16.)
USERSYM, COS(A), SIN(A), /FILL
x=10^(findgen(100)*.007)-.5
y=.6
for i=0,99 do begin
  ccol=(cmax-cmin)/100.*i+cmin
  plots,x(i),y,color=ccol,psym=8,symsize=.5
endfor
yc2=.1
xyouts,x(0)-.2,yc2,'i=90',charsize=.6
xyouts,x(99)-.5,yc2,'0',charsize=.6
endif

end

