pro sed_pap,dirm,intit,fluxfilt,nap

loadct,10

nfreq=200
ninc=10

;calculate fnorm
;fnorm=L/(4*pi*d^2)=(4*pi*R^2*sigma*T^4)/(4*pi*d^2)=(R^2*sigma*T^4)/d^2
;using model or specific input
c=2.9979e14
rstar=2.09
tstar=4000.
;d=140.
;or choose d=1kpc
;d=1000.
;d=140.
d=10.
sigma=5.67e-5
pc=3.0857e18
lsun=3.845e33
lum=4.*!pi*(rstar*6.955e10)^2*sigma*tstar^2*tstar^2
;or choose 1 lsun
lum=lsun
fnorm=lum/(4.*!pi)/d^2/pc/pc
;fnorm=tstar^2*(rstar*6.955e10/d/pc)^2*sigma*tstar^2
print,'fnorm',fnorm

;read in kurucz stellar spectrum used as input for comparison
readcol,'../models/parfiles/flx4000kg35.par',lama,junk,hnu,skipline=3,numline=1098
; convert from nm I guess
lama=lama*1.e-3
nuhnu=hnu/lama*2.9979e14
;f=hnu*rstar^2/(4*pi*d^2)
;solve for rstar using lum (in case we want to use lum=1lsun)
rstar2=lum/(4.*!pi*sigma)/tstar^2/tstar^2
nuhnu=4.*!pi*nuhnu*rstar2/d/d/pc/pc
;nuhnu=nuhnu/sigma*4*!pi
;nuhnu=nuhnu/tstar^2/tstar^2
;nuhnu=nuhnu*fnorm
print,'kurucz peak',max(nuhnu)
print,size(nuhnu)

;read in model, skip to aperture nap = 1,2,3
readcol,dirm+'/flux.dat',x4,f4,p4,skipline=(nap-1)*nfreq*ninc+1,$
  numline=nfreq*ninc

;read in peeled image
;readcol,dirm+'/eflux.dat',px4,pf4,skipline=3+nfreq*2

;integrate fnu*dnu=flam*dlam=(lam*flam)*d(ln(lam))
sum=0.
for ii=0,ninc-1 do begin
  n1=ii*nfreq
  n2=n1+nfreq-1
  x4hi=x4(n1:n2)
  f4hi=f4(n1:n2)
  x4hi=alog(x4hi*1.e-4)
  result=int_tabulated(x4hi,f4hi,/sort)
; end points are only half as big
  if ii eq 0 or ii eq ninc-1 then result=result/2.
  sum=sum+result
endfor
print,'integral over all angles',sum/(ninc-1)
x4hi=x4(0:nfreq-1)
f4hi=f4(0:nfreq-1)
x4hi=alog(x4hi*1.e-4)
result=int_tabulated(x4hi,f4hi,/sort)
print,'edge-on result, integrating lam*flam*dloglam',result
x4hi=x4(0:nfreq-1)
f4hi=f4(0:nfreq-1)/x4hi
result=int_tabulated(x4hi,f4hi,/sort)
print,'edge-on result, integrating flam*dlam',result

;integrate fnu*dnu=flam*dlam=(lam*flam)*d(ln(lam))
sum=0.
for ii=0,ninc-1 do begin
  n1=ii*nfreq
  n2=n1+nfreq-1
  x4hi=x4(n1:n2)
  f4hi=f4(n1:n2)
  x4hi=alog(x4hi*1.e-4)
  result=int_tabulated(x4hi,f4hi,/sort)
; end points are only half as big
  if ii eq 0 or ii eq ninc-1 then result=result/2.
  sum=sum+result
endfor
print,'integral over all angles',sum/(ninc-1)
x4hi=x4(0:nfreq-1)
f4hi=f4(0:nfreq-1)
x4hi=alog(x4hi*1.e-4)
result=int_tabulated(x4hi,f4hi,/sort)
print,'edge-on result, integrating lam*flam*dloglam',result
x4hi=x4(0:nfreq-1)
f4hi=f4(0:nfreq-1)/x4hi
result=int_tabulated(x4hi,f4hi,/sort)
print,'edge-on result, integrating flam*dlam',result

f4=f4*fnorm
;pf4=pf4*fnorm

;convert nuhnu and f4 to Jy; units are currently in lamflam=nufnu (erg...)
;first, divide by frequency to get erg/cm2/s/hz
;fnu=lamflam/nu
;c is in microns/s
;x4 is in microns
f4=f4/c*x4
;pf4=pf4/c*px4
nuhnu=nuhnu/c*lama
;now convert to mJy
f4=f4*1.e23*1.e3
;pf4=pf4*1.e23*1.e3
nuhnu=nuhnu*1.e23*1.e3

maxm=5.e-8
minm=1.e-14
maxm=max(f4)
;maxm=1000.
minm=maxm*1.e-8
print,'max',max(f4)

;GLIMPSE limits
;glam=[3.6,4.5,5.8,8.0]
;gf=[180.,200.,395.,360.]
;gf=gf/1.e3
glam=[3.6,4.5,5.8,8.0,24.,70.,160.]
;minimum limits
gf=[.001,.002,.005,.01,.03,.3,1.5]
gfmax=[365.,318.,813.,444.,6400.,41000.,17000.]
jhklam=[1.2,1.65,2.16]
jhkjy=[1630.,1050.,667.]
jhkjy=jhkjy*1.e3
jhk2m=[15.8,15.1,14.3]
f2m=jhkjy*10^(-0.4*jhk2m)

;f4=alog10(f4 > 1.e-10)
;nuhnu=alog10(nuhnu > 1.e-10)
;x4=alog10(x4 > 1.e-10)
;lama=alog10(lama > 1.e-10)
;maxm=2.
;minm=maxm-8

ii=9
!psym=0
cmax=240
cmin=10
plot,(x4(0:nfreq-1)),0.*(f4(nfreq*ii:nfreq*ii+nfreq-1)),$
/xlog,/ylog,$
yrange=[minm,1.05*maxm],$
xrange=[0.2,5000.],$
;xrange=[alog10(0.2),alog10(5000.)],$
xstyle=1,ystyle=1,title=intit,$
;linestyle=0,ytitle='!4k!3F!d!4k!3!n (ergs s!u-1!n cm!u-2!n)',$
linestyle=0,ytitle='Flux Density (mJy)',$
;xtitle='!4k!3(!4l!3m)',charsize=1.5,thick=5
xtitle='!4k!3(!4l!3m)',charsize=1.5,thick=5
for ii=0,9,1 do begin
ccol=(cmax-cmin)/11*ii+cmin
;oplot,(x(0:nfreq-1)),(f1(nfreq*ii:nfreq*ii+nfreq-1)),linestyle=2
;oplot,(x(0:nfreq-1)),(f2(nfreq*ii:nfreq*ii+nfreq-1)),linestyle=3
!psym=0
oplot,(x4(0:nfreq-1)),(f4(nfreq*ii:nfreq*ii+nfreq-1)),linestyle=0,color=ccol
!psym=0
;oplot,(x(0:nfreq-1)),(f(nfreq*ii:nfreq*ii+nfreq-1)),linestyle=1
endfor
oplot,lama,nuhnu,linestyle=1
oplot,glam,gf,psym=4
;oplot,px4,pf4
;oplot,glam,gf,linestyle=2
oplot,jhklam,f2m,psym=5

A = FINDGEN(17) * (!PI*2/16.)
USERSYM, COS(A), SIN(A), /FILL
x=10^(findgen(100)*.01)
y=100.
for i=0,99 do begin
  ccol=(cmax-cmin)/100.*i+cmin
  plots,x(i),y,color=ccol,psym=8,symsize=.5
endfor

;now integrate over filters to get 2mass & IRAC magnitudes
;readcol,'j_82a.txt',jlam,jfilt,skipline=7
;readcol,'h_44.txt',hlam,hfilt,skipline=7
;readcol,'ks_129.txt',klam,kfilt,skipline=4
;readcol,'irac_3.6.par',b1lam,b1filt,skipline=3
;readcol,'irac_4.5.par',b2lam,b2filt,skipline=3
;readcol,'irac_5.8.par',b3lam,b3filt,skipline=3
;readcol,'irac_8.0.par',b4lam,b4filt,skipline=3

filtlam=[1.2,1.65,2.16,3.6,4.5,5.8,8.0]
;print,interpol([655.,276.,248.,160,50],[2.179,3.547,3.761,4.769,8.756],5.8)
filtf=[1630.,1050.,667.,289.,183.,131.,71.]
mag=fltarr(ninc,10)
fluxfilt=fltarr(ninc,12)
;loop over inclination
for ii=0,ninc-1 do begin
;interpolate x4,f4 to filters
;convert back to Jy
  n1=ii*nfreq
  n2=n1+nfreq-1
  f=f4(n1:n2)/1.e3
  pol=p4(n1:n2)
  lam=x4(n1:n2)
; integrate over filter functions
  convfilt_jy,'../models/parfiles/j_82a.txt',7,lam,f,flux,0
  fluxfilt(ii,0)=flux
  convfilt_jy,'../models/parfiles/h_44.txt',7,lam,f,flux,0
  fluxfilt(ii,1)=flux
  convfilt_jy,'../models/parfiles/ks_129.txt',4,lam,f,flux,0
  fluxfilt(ii,2)=flux
  convfilt_jy,'../models/parfiles/irac_3.6.par',3,lam,f,flux,1
  fluxfilt(ii,3)=flux
  convfilt_jy,'../models/parfiles/irac_4.5.par',3,lam,f,flux,1
  fluxfilt(ii,4)=flux
  convfilt_jy,'../models/parfiles/irac_5.8.par',3,lam,f,flux,1
  fluxfilt(ii,5)=flux
  convfilt_jy,'../models/parfiles/irac_8.0.par',3,lam,f,flux,1
  fluxfilt(ii,6)=flux
  convfilt_jy,'../models/parfiles/mips_24.par',3,lam,f,flux,1
  fluxfilt(ii,7)=flux
  convfilt_jy,'../models/parfiles/mips_70a.par',3,lam,f,flux,1
  fluxfilt(ii,8)=flux
  convfilt_jy,'../models/parfiles/mips_160.par',3,lam,f,flux,1
  fluxfilt(ii,9)=flux
  convfilt_jy,'../models/parfiles/nband.par',3,lam,f,flux,0
  fluxfilt(ii,10)=flux
; k-band pol
  convfilt_jy,'../models/parfiles/ks_129.txt',4,lam,pol,flux,0
  fluxfilt(ii,11)=flux

;test, interpolate x4,f4 to filters
   fnew=interpol(f,lam,filtlam)
   pnew=interpol(pol,lam,filtlam)
;   mag(ii,0:6)=-2.5*alog10(fnew/filtf)
   mag(ii,0:6)=fnew
print,'fluxes integrated over filters'
print,fluxfilt(ii,*)
print,'fluxes interpolated to filter wavelengths'
print,fnew
print,'polarization'
print,pnew
;   print,-2.5*alog10(fnew/filtf)
;  this integrates over J filter and works
;  ;convert lam to freq
;  nufilt=c/jlam
;  nu4=c/x4(n1:n2)
;  fnew=interpol(f,nu4,nufilt)
;  ftop=int_tabulated(nufilt,fnew*jfilt,/sort)
;  fbot=int_tabulated(nufilt,jfilt,/sort)
;  fnew=ftop/fbot
;; test
;  fnew2=interpol(f,x4(n1:n2),1.2)
;  print,'j flux, mag',fnew*1.e3,-2.5*alog10(fnew/1630.),-2.5*alog10(fnew2/1630.)
endfor

;compute intrinsic stellar fluxes (for reddening computation)
;convert to Jy for output
;nuhnu=nuhnu/1.e3
;starfilt=fltarr(10)
;convfilt_jy,'j_82a.txt',7,lama,nuhnu,flux
;starfilt(0)=flux
;convfilt_jy,'h_44.txt',7,lama,nuhnu,flux
;starfilt(1)=flux
;convfilt_jy,'ks_129.txt',4,lama,nuhnu,flux
;starfilt(2)=flux
;convfilt_jy,'irac_3.6.par',3,lama,nuhnu,flux
;starfilt(3)=flux
;convfilt_jy,'irac_4.5.par',3,lama,nuhnu,flux
;starfilt(4)=flux
;convfilt_jy,'irac_5.8.par',3,lama,nuhnu,flux
;starfilt(5)=flux
;convfilt_jy,'irac_8.0.par',3,lama,nuhnu,flux
;starfilt(6)=flux
;convfilt_jy,'mips_24.par',3,lama,nuhnu,flux
;starfilt(7)=flux
;convfilt_jy,'mips_70.par',3,lama,nuhnu,flux
;starfilt(8)=flux
;convfilt_jy,'mips_160.par',3,lama,nuhnu,flux
;starfilt(9)=flux

end

