pro sede,dirm,nfreq,nincin,rstar,tstar,lumin,intit,d,nap,$
         Jy,atfilein,Av,flux,cs

loadct,10
ibar=0

ninc=nincin
atfile=atfilein
;mstar=mstarin
;mdot=mdotin
lum=lumin

;calculate fnorm
;fnorm=L/(4*pi*d^2)=(4*pi*R^2*sigma*T^4)/(4*pi*d^2)=(R^2*sigma*T^4)/d^2
;using model or specific input
c=2.9979e14
sigma=5.67e-5
pc=3.0857e18
lsun=3.845e33
;uncomment and comment next 2 lines out to calculate lum from rstar and tstar
lumstar=4.*!pi*(rstar*6.955e10)^2*sigma*tstar^2*tstar^2
lum=lum*lsun
;calculate accretion disk luminosity
;gn=6.6732d-8
;msol=1.989d33
;rsol=6.96d10
;mdot=mdot*msol/3.15576d7
;lacc=0.5*gn*msol/rsol*mstar/rstar*mdot 
;lum=lumstar+lacc
print,'stellar luminosity (Lsun)',lumstar/lsun
;print,'accretion luminosity (Lacc/Ltot)',lacc/lum
print,'total lum (Lsun)',lum/lsun
;print,mstar,mdot,msol 
fnorm=lum/(4.*!pi)/d^2/pc/pc
print,'fnorm',fnorm

;atfile='../models/parfiles/'+atfile
;read in kurucz stellar spectrum used as input for comparison
readcol,atfile,lama,junk,hnu,skipline=3
; convert from nm 
lama=lama*1.e-3
nuhnu=hnu/lama*2.9979e14
;f=hnu*rstar^2/(4*pi*d^2)
;solve for rstar using lum (in case we want to use lum=1lsun)
rstar2=lumstar/(4.*!pi*sigma)/tstar^2/tstar^2
nuhnu=4.*!pi*nuhnu*rstar2/d/d/pc/pc
print,'kurucz peak',max(nuhnu)
print,size(nuhnu)
;print,'calculated rstar ',sqrt(rstar2)/6.96e10

;read in model, skip to aperture
;readcol,dirm+'/flux.dat',x4,f4,skipline=nap*nfreq*ninc+1,numline=nfreq*ninc
;read in peeled spectrum
readcol,dirm+'/eflux.dat',x5,f5,skipline=3+nfreq*(nap),numline=nfreq
readcol,dirm+'/eflux.dat',x5s,f5s,skipline=3+nfreq*3+1+nfreq*(nap),$
  numline=nfreq
readcol,dirm+'/eflux.dat',x5d,f5d,skipline=3+nfreq*6+2,numline=nfreq

f5=f5*fnorm
f5s=f5s*fnorm
f5d=f5d*fnorm

;convert nuhnu and f4 to Jy; units are currently in lamflam=nufnu (erg...)
;first, divide by frequency to get erg/cm2/s/hz
;fnu=lamflam/nu
;c is in microns/s
;x4 is in microns
if Jy eq 1 then begin
  f5=f5/c*x5
  f5s=f5s/c*x5
  f5d=f5d/c*x5
  nuhnu=nuhnu/c*lama
  ;now convert to Jy
  f5=f5*1.e23
  f5s=f5s*1.e23
  f5d=f5d*1.e23
  nuhnu=nuhnu*1.e23
endif

maxm=max(f5)*3.
minm=maxm*1.e-5
print,'max',max(f5)

if jy eq 1 then begin
  ytit='Flux Density (Jy)'
endif else begin
  ytit='!4k!3F!d!4k!3!n (ergs s!u-1!n cm!u-2!n)'
endelse

;add in reddening
xnunew=x5
readcol,'../models/parfiles/kmh.par',klam,junk1,junk2,kkap
;interpolate onto flux grid
kapnew=interpol(kkap,klam,xnunew)
kapv=interpol(kkap,klam,0.55)
taul=kapnew/kapv/1.086*Av
extinct=exp(-taul)

; subtract direct and scattered spectrum (to get thermal only)
f5t=f5-f5s-f5d

f5=f5*extinct
f5s=f5s*extinct
f5d=f5d*extinct
f5t=f5t*extinct

if flux eq 't' then f5=f5t
if flux eq 'd' then f5=f5d
if flux eq 's' then f5=f5s

ii=ninc-1
!psym=0
cmax=240
cmin=10
plot,x5,0.*f5,$
/xlog,/ylog,$
yrange=[minm,maxm],$
xrange=[0.2,1500.],$
xmargin=[10,3],charthick=2,$
;xrange=[alog10(0.2),alog10(5000.)],$
xstyle=1,ystyle=1,title=intit,$
linestyle=0,ytitle=ytit,$
xtitle='!4k!3(!4l!3m)',charsize=cs,thick=2
;for ii=0,ninc-1,1 do begin
;ccol=(cmax-cmin)/11*ii+cmin
;!psym=0
;oplot,(x4(0:nfreq-1)),(f4(nfreq*ii:nfreq*ii+nfreq-1)),linestyle=0,color=ccol,$
; thick=2
;endfor
oplot,lama,nuhnu,linestyle=1
oplot,x5,f5,thick=2

if ibar eq 1 then begin
A = FINDGEN(17) * (!PI*2/16.)
USERSYM, COS(A), SIN(A), /FILL
x=10^(findgen(100)*.007)-.5
y=.6
for i=0,99 do begin
  ccol=(cmax-cmin)/100.*i+cmin
  plots,x(i),y,color=ccol,psym=8,symsize=.5
endfor
yc2=.1
xyouts,x(0)-.2,yc2,'i=90',charsize=.6
xyouts,x(99)-.5,yc2,'0',charsize=.6
endif

end

