      subroutine opacset(nu)
      
      implicit none
      
c      include 'star.com'
c      include 'kepler.com'
      include 'dust.com'
      
      integer i,i0,i1
      real f,fm1,temp
      real*8 nu


      if (nu.ge.nudust(1)) then

	  g=gdust(1)
	  pl=pldust(1)
	  kappa=kappad(1)
	  albedo=adust(1)
 
      elseif (nu.le.nudust(nlambda)) then

	  g=gdust(nlambda)
	  pl=pldust(nlambda)
	  kappa=kappad(nlambda)
	  albedo=adust(nlambda)

      else

          i0=1
          i1=nlambda
      
          do while(i1-i0 .gt. 1)
	      i=(i1+i0)/2
              if (nu.le.nudust(i)) then
	          i0=i
	      else
	          i1=i
	      endif
          end do
	  	  
          f=(nu-nudust(i1))/(nudust(i0)-nudust(i1))
          fm1=1.-f
          g=fm1*gdust(i1)+f*gdust(i0)
          pl=fm1*pldust(i1)+f*pldust(i0)
          kappa=fm1*kappad(i1)+f*kappad(i0)
          albedo=fm1*adust(i1)+f*adust(i0)

c          f=log(nu/nudust(i1))/log(nudust(i0)/nudust(i1))
c          g=gdust(i1)*(gdust(i0)/gdust(i1))**f
c          pl=pldust(i1)*(pldust(i0)/pldust(i1))**f
c          kappa=kappad(i1)*(kappad(i0)/kappad(i1))**f
c          albedo=adust(i1)*(adust(i0)/adust(i1))**f


      endif

      pc=0.39
      sc=1.0

      if (pl+pc .gt. 1.) then
c          write(*,*) 'Error - pl+pc > 1'
	  pc=0.99-pl
      endif
      
      g2=g*g
      g2p1=g2+1.
      onemg2=1.-g2
      twog=2.*g
c     baw, comment out, 02/06/02
c      p1maxinv=min((1.-g)**2/(1.+g),0.5)

c      nsigma=kappa*tau0
                   
      return
      end


      real function chiR(T)
      
      implicit none
      
      include 'dust.com'
      
      integer k
      real T,lT,f

      lT=alog(T)
      k=int((nT-1)*(lT-lTint(1))/(lTint(nT)-lTint(1)))+1
c      write(*,*) k,lT,lTint(1),lTint(nT)
      if ( (k .lt. 1) .or. (k .gt. (nT-1)) ) then
          write(*,*) 'chiR: index k out of bounds'
          write(*,*) '          k = ',k,'  T = ',T
          stop
      endif
      f=(lT-lTint(k))/(lTint(k+1)-lTint(k))

      chiR = (1.-f)*kappar(k)+f*kappar(k+1)
      
      return
      end
      

      real function KapP(T)
      
      implicit none
      
      include 'dust.com'
      
      integer k
      real T,lT,f

      lT=alog(T)
      k=int((nT-1)*(lT-lTint(1))/(lTint(nT)-lTint(1)))+1
c      write(*,*) k,lT,lTint(1),lTint(nT)
      if ( (k .lt. 1) .or. (k .gt. (nT-1)) ) then
          write(*,*) 'KapP: index k out of bounds'
          write(*,*) '          k = ',k,'  T = ',T
          stop
      endif
      f=(lT-lTint(k))/(lTint(k+1)-lTint(k))

      KapP = (1.-f)*kappap(k)+f*kappap(k+1)
      
      return
      end
      

C  ********************************************************************
C     Function to calculate dust temperature from condition of radiative
C     equilibrium
C  ********************************************************************
      real function dusttemp(i,j,k,na,T0,rstar,tstar,nphot)
      
      implicit none
      
c      include 'kepler.com'
      include 'dust.com'
c      include 'star.com'
      include 'grid.txt'

      integer i,j,k  ! grid cell index 
     +        ,na    ! number of photons absorbed
     +     ,nphot
c     real T0       ! initial guess for temperature
      real Td,Told,eps
      real*8 T0,rstar,tstar

      real KapP

      data eps /1.e-5/

c      print *,T0*11605.,i,j,na

      if (T0 .ne. 0.d0) then
         Td=T0
      else
         Td=0.1
      endif
      Told=0.5*Td

      do while( abs(Td-Told) .gt. eps*Td)
      
          Told=Td

c          print*,na,td*11605.,KapP(Td),KapP(Td/2.)
c          print*,massarr(i,j,k),i,j,k

	  Td=Tstar*( (na*3.1415927*Rstar*Rstar) /
     +               (nphot*kappav* KapP(Td)) )**0.25
          Td=Td*263818.1192/massarr(i,j,k)     !sqrt(rsun) 

c	  Td=247277.*( (na*0.918) /
c     +        (4.*nphot*massarr(i,j,k)*kappav* KapP(Td)) )**0.25
c	  Td=247277.*( (na*0.918) /
c     +        (4.*nphot*kappav* KapP(Td)) )**0.25
c          Td=Td/massarr(i,j,k)

          Td=min(Td,1600/11605.)
          Td=max(Td,10./11605.)
c          print*,'td',td
	  
c      print *,Td*11605. 

      end do
      
      dusttemp=Td
            
      return
      end
      

C  ********************************************************************
C     Temperature Correction procedure that calculates photon frequency 
C     for dust emission from the distribution 
C       
C                    kappa_nu*B_nu(T1)      kappa_nu*B_nu(T0)
C                 N1*----------------- - N0*-----------------
C        dP          kappa_P(T1)*B(T1)      kappa_P(T0)*B(T0)
C        --- =   -------------------------------------------
C        dnu                        N1 - N0
C
C     where N0 is the number of photons previously emitted at temperature
C     T0 and N1 is the total number to be emitted at temperature T1 
C  ********************************************************************
      real function dustfreq(T0)

      implicit none

      include 'random.com'
      include 'dust.com'

      real*8 T0
      real lT0

      integer j,i0,i1,i
      real xi,f,P0,P1,P

      real ran2,bbfreq

      if (T0 .ge. 1599./11605.) then
          dustfreq=bbfreq(T0)
          return
      endif
      if (T0 .le. 11./11605.) then
          dustfreq=bbfreq(T0)
          return
      endif
      
      lT0=dlog(T0)
      
      xi=ran2(idum)

      j=int((nT-1)*(lT0-lTint(1))/(lTint(nT)-lTint(1)))+1
      if ( (j .lt. 1) .or. (j .gt. (nT-1)) ) then
          write(*,*) 'dustfreq: index j out of bounds'
	  write(*,*) 'T0 =',11605.*T0
	  stop
      endif
      f=(lT0-lTint(j))/(lTint(j+1)-lTint(j))
      if ((f.lt.0.).or.(f.ge.1.)) then
          write(*,*) 'dustfreq: Tf = ',f,' out of bounds'
	  write(*,*) '          T0  = ',T0*11606.
      endif
      

      i0=1
      i1=nnu

      P0=  (1.-f)*kapdBint(j,i0) + f*kapdBint(j+1,i0)
      if(xi.lt.P0) then
          if (P0 .gt. 0.) then
              dustfreq=T0*xi*nuint(1)/P0
	  else
	      dustfreq=T0*nuint(1)
	  endif
	  return
      endif

      P1=  (1.-f)*kapdBint(j,i1) + f*kapdBint(j+1,i1)
      if (P1 .gt. 1.) then
          write(*,*) 'dustfreq: P1>1, P1 = ',P1
	  P1=1.
      endif
      if (xi.ge.P1) then
          if (P1 .lt. 1.) then
	      if (xi.lt.1.) then
                  dustfreq=T0*nuint(nnu)*(1.-P1)/(1.-xi)
	      else
	          dustfreq=T0*nuint(nnu)
	      endif
          else
	      dustfreq=T0*nuint(nnu)
	  endif
          return
      endif

      do while((i1-i0).gt.1)

          i=(i0+i1)/2
          P=  (1.-f)*kapdBint(j,i) + f*kapdBint(j+1,i)

	  if (P .gt. 1.) then
	      if (i.ge.nnu-2) then
	          write(*,*)'dustfreq: P>1; i,P = ',i,P
	      endif
	      P=1.
	  endif

          if (P .lt. P0) then
	      write(*,*) 'dustfreq: P<P0; P0,P,P1 = ',P0,P,P1
	      P0=P
	      i0=i
	  endif
          if (P .gt. P1) then
	      write(*,*) 'dustfreq: P>P1; P0,P,P1 = ',P0,P,P1
	      P1=P
	      i1=1
	  endif
	  
          if (P.gt.xi) then
              i1=i
              P1=P
          else
              i0=i
              P0=P
          endif

      end do

      if (P1.le.P0) then
          write(*,*) 'dustfreq: P1<=P0; P0, P1 = ',P0,P1
	  stop
      endif
      
c      f=(xi-P0)/(P1-P0)
      if (xi.lt.P0) then
          write(*,*) 'dustfreq: xi<P0, xi,P0 = ',xi,P0
          f=0.
      elseif (xi.gt.P1) then
          write(*,*) 'dustfreq: xi>P1, xi,P1 = ',xi,P1
          f=1.
      elseif (P0.le.0.) then
          write(*,*) 'dustfreq: P0<=0, P0,i0,i1 = ',P0,i0,i1
	  f=0.5
      elseif (P1.le.0.) then
          write(*,*) 'dustfreq: P1<=0, P1 = ',P1
	  stop
      elseif (xi.le.0.) then
          write(*,*) 'dustfreq: xi<=0, xi = ',xi
	  stop
      else
          f=log(xi/P0)/log(P1/P0)
      endif

      dustfreq= T0 * nuint(i0) * (nuint(i1)/nuint(i0))**f

      if ((f.lt.0.).or.(f.ge.1.)) then
          write(*,*) 'dustfreq: Pf = ',f,' out of bounds'
	  write(*,*) '          xi = ',xi,'freq = ',1.24/dustfreq
      endif

      return
      end
 

      subroutine dustinit(dustname)
      
      implicit none

      include 'dust.com'
c      include 'star.com'
      
      integer i,iv
      real lam,sigabs,sigscat,f,hgg,kap,pmax,thet,cext,csca
      real Tmin,Tmax,numin,numax
      character dustname*50

c      data Tmin,Tmax,numin,numax /1.,10000.,0.003,3./
      data Tmin,Tmax /1.,2000./

      numax=32.                 ! in units of T; i.e., numax=32.k*T
      numin=numax/1024.

      open(7,file=dustname,status='old')

c     standard dust files
      do i=1,nlammax      
         read(7,*,end=100) lam,cext,csca,kap,hgg,pmax,thet
         if (lam .le. 0.55) iv=i
         lamdust(i)=10000.*lam
         nudust(i)=12400./lamdust(i)
         kappad(i)=kap   
         adust(i)=csca/cext
         gdust(i)=hgg
         pldust(i)=pmax
      end do

c     testing with jon's 2-D code using ism-stnd.dat dust file
c      do i=1,nlammax
c         read(7,*,end=100) lam,cext,csca
c         print*,cext,csca
c         if (lam .le. 0.55) iv=i
c         cext=(cext+csca)*27.0186088    !reading in cabs
c         csca=csca*27.0186088
c         lamdust(i)=10000.*lam
c         nudust(i)=12400./lamdust(i)
c         kappad(i)=cext
c         adust(i)=csca/cext
c         gdust(i)=0.0
c         pldust(i)=0.
c     grey body
c         cext=(3.01953+5.16705)*27.0186088
c         csca=0.5*cext
c         lamdust(i)=10000.*lam
c         nudust(i)=12400./lamdust(i)
c         kappad(i)=cext
c         adust(i)=csca/cext
c         gdust(i)=0.0
c         pldust(i)=0.
c      enddo

      write(*,*) 'error, too many wavelengths in dust file'
      stop
      
  100 continue
  
      close(7)
      nlambda=i-1

C     normalize opacity array
      
      f=(5500.-lamdust(iv))/(lamdust(iv+1)-lamdust(iv))
      kappav=(1.-f)*kappad(iv)+f*kappad(iv+1)
      print*,'kappav',kappav
      
      do i=1,nlambda
          kappad(i)=kappad(i)/kappav
      end do

C     set up temperature and frequency arrays for Planck mean opacity
      do i=1,nT
          lTint(i)=alog(Tmin/11605.)+(i-1)*alog(Tmax/Tmin)/(nT-1)
	  Tint(i)=exp(lTint(i))
c	  write(*,*) i,Tint(i),lTint(i)
      end do

      do i=1,nnu
          nuint(i)=numin+(i-1)*(numax-numin)/(nnu-1)
      end do
      
      call setemiss()

      return
      end      

      
      subroutine setemiss() 

      implicit none

      include 'dust.com'
      
      integer i,j
      real dx,chidBint

      real nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff      
c      real nu0,dnu,kappa0,kappa1,chi0,chi1,Teff      
      real*8 nu2
      common /kappa_B_int/ nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff

      real kappaB,kappadB,dB,chidB
      external kappaB,kappadB,dB,chidB
      
      do i=1,nT
      
          Teff=Tint(i)
	  
	  nu1=0.       ! be sure to multiply by Teff if nu1 .ne. 0
          nu2=nu1
          call opacset(nu2)
          chi1=kappa
	  kappa1=(1.-albedo)*kappa    !kappa1 is absorptive opacity
	  
	  do j=1,nnu

	      nu0=nu1
	      nu1=nuint(j)*Teff !frequency array is scalled to Teff
              nu2=nu1
	      dnu=nu1-nu0
	      dx=dnu/Teff       !x=h*nu/kT
              chi0=chi1
	      kappa0=kappa1
	      call opacset(nu2)
              chi1=kappa
	      kappa1=(1.-albedo)*kappa

              if ( (nu0/Teff) .lt. 50.) then
	          call QSIMP(kappaB,0.,1.,kapBint(i,j))
	          call QSIMP(kappadB,0.,1.,kapdBint(i,j))
	          call QSIMP(dB,0.,1.,dBint(i,j))
                  call QSIMP(chidB,0.,1.,chidBint)
	      else
	          kapBint(i,j)=0.
		  kapdBint(i,j)=0.
		  dBint(i,j)=0.
		  chidBint=0.
	      endif

c             sum integration step into cumulative integral

	      if (j.eq.1) then
                  kapBint(i,j)=dx*kapBint(i,j)
                  kapdBint(i,j)=dx*kapdBint(i,j)
                  dBint(i,j)=dx*dBint(i,j)
                  kappar(i)=dx*chidBint
	      else 
                  kapBint(i,j)=dx*kapBint(i,j)+kapBint(i,j-1)
                  kapdBint(i,j)=dx*kapdBint(i,j)+kapdBint(i,j-1)
                  dBint(i,j)=dx*dBint(i,j)+dBint(i,j-1)
                  kappar(i)=dx*chidBint+kappar(i)
	      endif

	  end do

          kappar(i)=1./kappar(i)
          kappap(i)=kapBint(i,nnu) ! + integral to infinity

c          write(*,*) 'i,Teff,kappa P, R = ',i,Teff*11605.,
c     +               kappap(i),kappar(i)
	  
          do j=1,nnu-1
	      kapdBint(i,j)=kapdBint(i,j)/kapdBint(i,nnu)
	      dBint(i,j)=dBint(i,j)/dBint(i,nnu)
	  end do
	  kapdBint(i,nnu)=1.
	  dBint(i,nnu)=1.
	  	  	  
      end do
      
      return
      end


C  ********************************************************************
C     Function to Calculate LTE Emissivity j_nu=kappa_nu*B_nu
C  ********************************************************************
      real function kappaB(f)
      
      implicit none

      real f,nu
      real Bnu
      
      real nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff      
      common /kappa_B_int/ nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff
      
      nu=nu0+f*dnu
      kappaB=((1.-f)*kappa0+f*kappa1)*Bnu(nu,Teff)
      
      return
      end
      
            
C  ********************************************************************
C     Function to Calculatekappa_nu*dB_nu/dT
C  ********************************************************************
      real function kappadB(f)
      
      implicit none

      real f,nu
      real dBnu
      
      real nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff      
      common /kappa_B_int/ nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff
      
      nu=nu0+f*dnu
      kappadB=((1.-f)*kappa0+f*kappa1)*dBnu(nu,Teff)
      
      return
      end

C  ********************************************************************
C     Function to Calculate (1/chi_nu)*dB_nu/dT
C  ********************************************************************
      real function chidB(f)
      
      implicit none

      real f,nu
      real dBnu
      
      real nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff      
      common /kappa_B_int/ nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff
      
      nu=nu0+f*dnu
      chidB=dBnu(nu,Teff)/((1.-f)*chi0+f*chi1)
      
      return
      end

C  ********************************************************************
C     Function to Calculate dB_nu/dT for integration
C  ********************************************************************
      
      real function dB(f)
      
      implicit none

      real f,nu
      real dBnu
      
      real nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff      
      common /kappa_B_int/ nu0,nu1,dnu,kappa0,kappa1,chi0,chi1,Teff
      
      nu=nu0+f*dnu
      dB=dBnu(nu,Teff)
      
      return
      end

      
      real function dBBfreq(T0)

      implicit none

      include 'random.com'
      include 'dust.com'

      real*8 T0
      real lT0

      integer j,i0,i1,i
      real xi,f,P0,P1,P

      real ran2


      lT0=dlog(T0)
      
      xi=ran2(idum)

      j=int((nT-1)*(lT0-lTint(1))/(lTint(nT)-lTint(1)))+1
      if ( (j .lt. 1) .or. (j .gt. (nT-1)) ) then
          write(*,*) 'dBBfreq: index j out of bounds'
	  write(*,*) '          T0  = ',T0*11606.
	  stop
      endif
      f=(lT0-lTint(j))/(lTint(j+1)-lTint(j))
      if ((f.lt.0.).or.(f.ge.1.)) then
          write(*,*) 'dBBfreq: Tf = ',f,' out of bounds'
	  write(*,*) '          T0  = ',T0*11606.
      endif
      

      i0=1
      i1=nnu

      P0=  (1.-f)*dBint(j,i0) + f*dBint(j+1,i0)
      if(xi.lt.P0) then
          if (P0 .gt. 0.) then
              dBBfreq=T0*xi*nuint(1)/P0
	  else
	      dBBfreq=T0*nuint(1)
	  endif
	  return
      endif

      P1=  (1.-f)*dBint(j,i1) + f*dBint(j+1,i1)
      if (P1 .gt. 1.) then
          write(*,*) 'dBBfreq: P1>1, P1 = ',P1
	  P1=1.
      endif
      if (xi.ge.P1) then
          if (P1 .lt. 1.) then
	      if (xi.lt.1.) then
                  dBBfreq=T0*nuint(nnu)*(1.-P1)/(1.-xi)
	      else
	          dBBfreq=T0*nuint(nnu)
	      endif
          else
	      dBBfreq=T0*nuint(nnu)
	  endif
          return
      endif

      do while((i1-i0).gt.1)

          i=(i0+i1)/2
          P=  (1.-f)*dBint(j,i) + f*dBint(j+1,i)

	  if (P .gt. 1.) then
	      if (i.ge.nnu-2) then
	          write(*,*)'dBBfreq: P>1; i,P = ',i,P
	      endif
	      P=1.
	  endif

          if (P .lt. P0) then
	      write(*,*) 'dBBfreq: P<P0; P0,P,P1 = ',P0,P,P1
	      P0=P
	      i0=i
	  endif
          if (P .gt. P1) then
	      write(*,*) 'dBBfreq: P>P1; P0,P,P1 = ',P0,P,P1
	      P1=P
	      i1=1
	  endif
	  
          if (P.gt.xi) then
              i1=i
              P1=P
          else
              i0=i
              P0=P
          endif

      end do

      if (P1.le.P0) then
          write(*,*) 'dBBfreq: P1<=P0; P0, P1 = ',P0,P1
	  stop
      endif
      
c      f=(xi-P0)/(P1-P0)
      if (xi.lt.P0) then
          write(*,*) 'dBBfreq: xi<P0, xi,P0 = ',xi,P0
          f=0.
      elseif (xi.gt.P1) then
          write(*,*) 'dBBfreq: xi>P1, xi,P1 = ',xi,P1
          f=1.
      elseif (P0.le.0.) then
          write(*,*) 'dBBfreq: P0<=0, P0,i0,i1 = ',P0,i0,i1
	  f=0.5
      elseif (P1.le.0.) then
          write(*,*) 'dBBfreq: P1<=0, P1 = ',P1
	  stop
      elseif (xi.le.0.) then
          write(*,*) 'dBBfreq: xi<=0, xi = ',xi
	  stop
      else
          f=log(xi/P0)/log(P1/P0)
      endif

      dBBfreq= T0 * nuint(i0) * (nuint(i1)/nuint(i0))**f

      if ((f.lt.0.).or.(f.ge.1.)) then
          write(*,*) 'dBBfreq: Pf = ',f,' out of bounds'
	  write(*,*) '          xi = ',xi,'freq = ',1.24/dBBfreq
      endif

      return
      end
 

            
