      subroutine peeloff(dum1,dum2,dum3,dum4,dum5,dum6,dum7
     1   ,dum9,dum10,dum11,dum12,dum13
     1   ,pi,r2p,hit,htot,dum15,dum16
     1   ,tsum,dum14,dum8,iflag,iphot,eps)

c     don't want this routine to change any of the input variables!!!!
c     fortran 90 would make this easier....

c     integrate optical depth until photon exits in a specified
c     direction, or hits the star.

      implicit none

      real*8 s,dsmax,xp1,yp1,zp1,ux1,uy1,uz1
     1   ,pi,r2p,sip,sqp,sup,svp,rsq1
     $   ,bmu,sinbm,yimage,ximage
     $   ,costp,sintp,cospp,sinpp,phip
     $   ,taumax,dtau,eps,deps
      real*8 tsum,rtau,rsqnew
     1   ,xpnew,ypnew,zpnew,opac,dscoste
     1   ,dum1,dum2,dum3,dum4,dum5,dum6,dum7,dum9,dum10
     1   ,dum11,dum12,dum13,dum3a,dum15,dum16,rtot1
     1   ,phinew,ri1,hit,htot,peak,xold,yold,zold
     1   ,rhopold,factor,dt,lp1,beta,wt,dtau_eps,freq,rho2

      integer dum14(3),ii(3),ioffset(3)
      integer idust,ix,iy,irho,dum8,iphot,iflag,ir,it,ip,inub,iw,ift
     $ ,idust2,id2

      character routine*20

      include 'opacin.txt'
      include 'tts.txt'
      include 'grid.txt'
      include 'filt.txt'

      routine='peeloff_3d'

c     copy input variables so as not to change them
      xp1=dum1
      yp1=dum2
      zp1=dum3
      xold=xp1
      yold=yp1
      zold=zp1
      sip=dum4
      sqp=dum5
      sup=dum6
      svp=dum7
      idust=dum8
      costp=dum9
      sintp=dum10
      cospp=dum11
      sinpp=dum12
      phip=dum13
      ii(1)=dum14(1)
      ii(2)=dum14(2)
      ii(3)=dum14(3)
      rsq1=dum15
      rtot1=dum16

c     print*,'input variables'
c     print*,xp1,yp1,zp1,sip,sqp,sup,svp,idust,costp,sintp,cospp,
c     1     sinpp,phip,ii(1),ii(2),ii(3)

      tsum=0.d0
      taumax=25.d0
c     print*,'eps',eps
c     print*,'it',ii(2)

c     rsq1=xp1*xp1+yp1*yp1+zp1*zp1
      rhopold=rtot1
      if (rhopold.lt.rarr(1)) print*,'wo!  peeloff, error, r ',rhopold
      ux1=sinte*cospe
      uy1=sinte*sinpe
      uz1=coste

c     print*,'ux1,uy1,uz1',ux1,uy1,uz1
c     print*,'rsq',rsq1,xp1*xp1+yp1*yp1+zp1*zp1
c     print*,'rtot',rtot1,dsqrt(xp1*xp1+yp1*yp1+zp1*zp1)

      ir=ii(1)
      it=ii(2)
      ip=ii(3)
c	calculate dust type where photon scatters for stokes call after
c	loop
      id2=dustarr(ir,it,ip)

10    continue
      call testgrid(xp1,yp1,zp1,rsq1,rtot1,ii,routine,iphot,r2p,uz1)
      ir=ii(1)
      it=ii(2)
      ip=ii(3)
      idust2=dustarr(ir,it,ip)

      if (npg.gt.2.and.ntg.gt.2) then
         call find_wall(dt,ioffset,aarr(ip),aarr(ip+1),barr(ip)
     &        ,barr(ip+1),0.d0,0.d0,0.d0,0.d0,r2arr(ir),r2arr(ir+1)
     &        ,tan2arr(it),tan2arr(it+1),ux1,uy1,uz1,xp1,yp1,zp1)
c     print*,'dt ',dt
c     print*,'ioffsets ',ioffset(1),ioffset(2),ioffset(3)
      else if (ntg.gt.2) then
         call find_wall_2D(dt,ioffset,r2arr(ir),r2arr(ir+1)
     &        ,tan2arr(it),tan2arr(it+1),ux1,uy1,uz1,xp1,yp1,zp1)
      else
         call find_wall_1D(dt,ioffset,r2arr(ir),r2arr(ir+1)
     &        ,ux1,uy1,uz1,xp1,yp1,zp1)
      endif

      if (dt.lt.0.d0) then
         print*,'problem with find_wall! did not find surface! '
         print*,'in peeloff,ir,rtot2,r2arr(ir)',ir,rsq1,r2arr(ir)
         print*,'ux,uy,uz,iphot',ux1,uy1,uz1,iphot
         print*,'xtot,ytot,ztot',xp1,yp1,zp1
         dt=eps*(rarr(ir+1)-rarr(ir))
      endif

      if (tdust(ir,it,ip).lt.1599./11605.) then
         opac=kapd(idust2)*densarr(ir,it,ip)
      else
         opac=0.d0
      endif
      deps=(rarr(ir+1)-rarr(ir))*eps
      dtau_eps=opac*deps
      if (dtau_eps.gt.0.01) then
         print*,''
         print*,'WARNING, in peeloff_3d'
         print*,'deps is too big, opac*deps',dtau_eps
         print*,''
      endif
      dtau=opac*dt+dtau_eps
c     dtau=opac*(dt+deps)      !optical depth to edge of cell
      tsum=tsum+dtau
      if ((tsum).gt.taumax) then
c        photon weight will be too small to matter
         go to 300
      endif

      ii(1)=ii(1)+ioffset(1)
      ii(2)=ii(2)+ioffset(2)
      ii(3)=ii(3)+ioffset(3)
c     account for crossing the phi=0 plane:
      if (ii(3).eq.0) ii(3)=npg-1
      if (ii(3).eq.npg) ii(3)=1

 50   xpnew=xp1+(dt+deps)*ux1
      ypnew=yp1+(dt+deps)*uy1
      zpnew=zp1+(dt+deps)*uz1
      rsqnew=xpnew*xpnew+ypnew*ypnew+zpnew*zpnew
      if ((rsqnew-rsq1).eq.0.d0) then
         print*,''
         print*,'ERROR, in peeloff_3d'
         print*,'rsqnew=rsq, step size too small'
         print*,'increasing deps'
         deps=deps*2.d0
         go to 50
      endif
      xp1=xpnew
      yp1=ypnew
      zp1=zpnew
      rsq1=rsqnew
      rtot1=dsqrt(rsq1)
c     test to see if photon exits system
      if (rsq1.gt.r2arr(nrg)) then
c        photon exits system
         go to 250
      endif

      if (rsq1.lt.r2arr(1)) then
         go to 300
      endif

      go to 10
250   continue
c     write(6,*) 'tsum.gt.tau',tsum,tau

      
c     if you are here, you left the atmosphere and are heading to HST
c     weight photon intensity by optical depth and
c     account for probability of intercepting solid angle of scattered light.
c     sfactor is 1/4pi
      if (iflag.eq.1) then
c     factor=exp(-tsum)*sfactor
         factor=dexp(-tsum)
         sip=sip*factor
         sqp=sqp*factor
         sup=sup*factor
         svp=svp*factor
c     if (sip.lt.1.e-10) go to 300
         call findangle3(pi,r2p,costp,sintp,phip,cospp,sinpp
     1        ,coste,sinte,phie,cospe,sinpe,bmu,sinbm,phinew,ri1)
c     don't care about phinew
         if (idust.lt.2) then
            call stokespeel(idust,sip,sqp,sup,svp,coste,sinte
     1           ,hit,htot,pi,r2p,ri1,bmu,costp,sintp,id2)
         else
         	print*,'oops, error, idust is wrong'
         	stop
c            call stokespeel6(sip,sqp,sup,svp,coste,sinte
c     1           ,hit,htot,pi,r2p,peak,ri1,bmu,costp,sintp,id2)
         endif
      else
         factor=dexp(-tsum)
         sip=sip*factor
         sqp=sqp*factor
         sup=sup*factor
         svp=svp*factor
      endif

      yimage = zold*sinte-yold*coste*sinpe
     &     -xold*coste*cospe
      ximage = yold*cospe-xold*sinpe
c     print*,'ximage,rmaxi,fractxh ',ximage,rmaxi,fractxh
      ix = int((ximage+rmaxi)/fractxh)+1
      iy = int((yimage+rmaxi)/fractxh)+1
      
      if (ix.le.nxhst.and.iy.le.nxhst.and.ix.gt.0.and.iy.gt.0) then
c     change wave to frequence
         freq=2.9979d14/wave
c     see if wavelength falls into any of the filter functions
         iw=0
         ift=0
c     print*,'wave',wave
         if (freq.gt.wnic1(1).and.freq.lt.wnic1(nic1)) then
            call locate(wnic1,nic1,freq,iw)
            ift=1
c     wt=fnic1(iw)
            if (iw.lt.1.or.iw.ge.nic1) print*,'iw wrong',iw,ift
c            wt=0.5*(fnic1(iw+1)+fnic1(iw))*(wnic1(iw+1)-wnic1(iw))
            wt=fnic1(iw)
c            print*,''
c            print*,'weight',wt
c            print*,'freq,wt,ift,iw',freq,wt,ift,iw
c            print*,'1.2398/nub',1.2398/nub
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif

         if (freq.gt.wnic2(1).and.freq.lt.wnic2(nic2)) then
            call locate(wnic2,nic2,freq,iw)
c     print*,'locate on nic2,freq,iw',freq,iw
            ift=2
c     wt=fnic2(iw)
            if (iw.lt.1.or.iw.ge.nic2) print*,'iw wrong',iw,ift
c            wt=0.5*(fnic2(iw+1)+fnic2(iw))*(wnic2(iw+1)-wnic2(iw))
            wt=fnic2(iw)
c     print*,'freq,wt,ift,iw',freq,wt,ift,iw
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif

         if (freq.gt.wnic3(1).and.freq.lt.wnic3(nic3)) then
            call locate(wnic3,nic3,freq,iw)
c     print*,'locate on nic3,freq,iw',freq,iw
            ift=3
c     wt=fnic3(iw)
            if (iw.lt.1.or.iw.ge.nic3) print*,'iw wrong',iw,ift
c            wt=0.5*(fnic3(iw+1)+fnic3(iw))*(wnic3(iw+1)-wnic3(iw))
            wt=fnic3(iw)
c     print*,'freq,wt,ift,iw',freq,wt,ift,iw
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif

         if (freq.gt.wir1(1).and.freq.lt.wir1(nir)) then
            call locate(wir1,nir,freq,iw)
            ift=4
c     wt=fir1(iw)
            if (iw.lt.1.or.iw.ge.nir) print*,'iw wrong',iw,ift
c            wt=0.5*(fir1(iw+1)+fir1(iw))*(wir1(iw+1)-wir1(iw))
            wt=fir1(iw)
c     print*,'freq,wt,ift,iw',freq,wt,ift,iw
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif

         if (freq.gt.wir2(1).and.freq.lt.wir2(nir)) then
            call locate(wir2,nir,freq,iw)
            ift=5
c     wt=fir2(iw)
            if (iw.lt.1.or.iw.ge.nir) print*,'iw wrong',iw,ift
c            wt=0.5*(fir2(iw+1)+fir2(iw))*(wir2(iw+1)-wir2(iw))
            wt=fir2(iw)
c     print*,'freq,wt,ift,iw',freq,wt,ift,iw
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif

         if (freq.gt.wir3(1).and.freq.lt.wir3(nir)) then
            call locate(wir3,nir,freq,iw)
            ift=6
c     wt=fir3(iw)
            if (iw.lt.1.or.iw.ge.nir) print*,'iw wrong',iw,ift
c            wt=0.5*(fir3(iw+1)+fir3(iw))*(wir3(iw+1)-wir3(iw))
            wt=fir3(iw)
c     print*,'freq,wt,ift,iw',freq,wt,ift,iw
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif

         if (freq.gt.wir4(1).and.freq.lt.wIr4(nir)) then
            call locate(wir4,nir,freq,iw)
            ift=7
c     wt=fir4(iw)
            if (iw.lt.1.or.iw.ge.nir) print*,'iw wrong',iw,ift
c            wt=0.5*(fir4(iw+1)+fir4(iw))*(wir4(iw+1)-wir4(iw))
            wt=fir4(iw)
c     print*,'freq,wt,ift,iw',freq,wt,ift,iw
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif

         if (freq.gt.wmp1(1).and.freq.lt.wmp1(nmp1)) then
            call locate(wmp1,nmp1,freq,iw)
            ift=8
c     wt=fmp1(iw)
            if (iw.lt.1.or.iw.ge.nmp1) print*,'iw wrong',iw,ift
c            wt=0.5*(fmp1(iw+1)+fmp1(iw))*(wmp1(iw+1)-wmp1(iw))
            wt=fmp1(iw)
c     print*,'freq,wt,ift,iw',freq,wt,ift,iw
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif

         if (freq.gt.wmp2(1).and.freq.lt.wmp2(nmp2)) then
            call locate(wmp2,nmp2,freq,iw)
            ift=9
c     wt=fmp2(iw)
            if (iw.lt.1.or.iw.ge.nmp2) print*,'iw wrong',iw,ift
c            wt=0.5*(fmp2(iw+1)+fmp2(iw+1))*(wmp2(iw+1)-wmp2(iw))
            wt=fmp2(iw)
c     print*,'freq,wt,ift,iw',freq,wt,ift,iw
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif

         if (freq.gt.wmp3(1).and.freq.lt.wmp3(nmp3)) then
            call locate(wmp3,nmp3,freq,iw)
            ift=10
c     wt=fmp3(iw)
            if (iw.lt.1.or.iw.ge.nmp3) print*,'iw wrong',iw,ift
c            wt=0.5*(fmp3(iw+1)+fmp3(iw))*(wmp3(iw+1)-wmp3(iw))
            wt=fmp3(iw)
c     print*,'freq,wt,ift,iw',freq,wt,ift,iw
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
c     print*,'filter',ift
         
c     midIR filters, assume box
         
         if (freq.gt.wmir(1).and.freq.lt.wmir(2)) then
            wt=fmir(1)
            ift=11
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(3).and.freq.lt.wmir(4)) then
            wt=fmir(2)
            ift=12
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(5).and.freq.lt.wmir(6)) then
            wt=fmir(3)
            ift=13
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(7).and.freq.lt.wmir(8)) then
            wt=fmir(4)
            ift=14
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(9).and.freq.lt.wmir(10)) then
            wt=fmir(5)
            ift=15
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(11).and.freq.lt.wmir(12)) then
            wt=fmir(6)
            ift=16
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(13).and.freq.lt.wmir(14)) then
            wt=fmir(7)
            ift=17
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(15).and.freq.lt.wmir(16)) then
            wt=fmir(8)
            ift=18
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(17).and.freq.lt.wmir(18)) then
            wt=fmir(9)
            ift=19
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(19).and.freq.lt.wmir(20)) then
            wt=fmir(10)
            ift=20
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif
         if (freq.gt.wmir(21).and.freq.lt.wmir(22)) then
            wt=fmir(11)
            ift=21
            tihst(ix,iy,ift) = tihst(ix,iy,ift) + (sip)*wt
            tqhst(ix,iy,ift) = tqhst(ix,iy,ift) + (sqp)*wt
            tuhst(ix,iy,ift) = tuhst(ix,iy,ift) + (sup)*wt
            tvhst(ix,iy,ift) = tvhst(ix,iy,ift) + (svp)*wt
         endif 
      endif
	 
      rho2=ximage**2+yimage**2

c     bin in frequency
      inub=min(max(int(nfreq*dlog(nub/numin)/lnurat)+1,1),nfreq)

      if (rho2.lt.aperture2(1)) then
         ti(inub,1)=ti(inub,1)+(sip)
         tq(inub,1)=tq(inub,1)+(sqp)
         tu(inub,1)=tu(inub,1)+(sup)
         tv(inub,1)=tv(inub,1)+(svp)
         numt(inub,1)=numt(inub,1)+1
         ti2(inub,1)=ti2(inub,1)+sip*sip
         tq2(inub,1)=tq2(inub,1)+sqp*sqp
         tu2(inub,1)=tu2(inub,1)+sup*sup
         tv2(inub,1)=tv2(inub,1)+svp*svp
         if (iflag.eq.1.and.ior.eq.1) then
            tis(inub,1)=tis(inub,1)+(sip)
            tqs(inub,1)=tqs(inub,1)+(sqp)
            tus(inub,1)=tus(inub,1)+(sup)
            tvs(inub,1)=tvs(inub,1)+(svp)
         endif
      endif
      if (rho2.lt.aperture2(2)) then
         ti(inub,2)=ti(inub,2)+(sip)
         tq(inub,2)=tq(inub,2)+(sqp)
         tu(inub,2)=tu(inub,2)+(sup)
         tv(inub,2)=tv(inub,2)+(svp)
         numt(inub,2)=numt(inub,2)+1
         ti2(inub,2)=ti2(inub,2)+sip*sip
         tq2(inub,2)=tq2(inub,2)+sqp*sqp
         tu2(inub,2)=tu2(inub,2)+sup*sup
         tv2(inub,2)=tv2(inub,2)+svp*svp
         if (iflag.eq.1.and.ior.eq.1) then
            tis(inub,2)=tis(inub,2)+(sip)
            tqs(inub,2)=tqs(inub,2)+(sqp)
            tus(inub,2)=tus(inub,2)+(sup)
            tvs(inub,2)=tvs(inub,2)+(svp)
         endif
      endif
      if (rho2.lt.aperture2(3)) then
         ti(inub,3)=ti(inub,3)+(sip)
         tq(inub,3)=tq(inub,3)+(sqp)
         tu(inub,3)=tu(inub,3)+(sup)
         tv(inub,3)=tv(inub,3)+(svp)
         numt(inub,3)=numt(inub,3)+1
         ti2(inub,3)=ti2(inub,3)+sip*sip
         tq2(inub,3)=tq2(inub,3)+sqp*sqp
         tu2(inub,3)=tu2(inub,3)+sup*sup
         tv2(inub,3)=tv2(inub,3)+svp*svp
         if (iflag.eq.1.and.ior.eq.1) then
            tis(inub,3)=tis(inub,3)+(sip)
            tqs(inub,3)=tqs(inub,3)+(sqp)
            tus(inub,3)=tus(inub,3)+(sup)
            tvs(inub,3)=tvs(inub,3)+(svp)
         endif
      endif

      if(iflag.eq.0.and.ior.eq.1) then !just want direct *stellar* flux
         estar(inub)=estar(inub)+sip
      end if
      
 300  continue
      return
      end
      
