c     *******************************************************

      subroutine setup(cwav,cfldust,ctherm,nwav,MXWAV,atname,dustname)

      implicit none

      real*8 rmine1,rmine2,gn,k,muc,mh,rcgs,mcgs,honr,h
      integer MXWAV,nwav
      character cwav(MXWAV)*(*),cfldust(MXWAV)*(*),ctherm(MXWAV)*(*)
	

      include 'tab.txt'
      include 'tts.txt'
      include 'stokes.txt'
      include 'tabl.txt'
      include 'opacin.txt'
      include 'out.txt'
c      include 'mrncoef.txt'
      include 'random.txt'

c      character cfile*50
      character cflpar*50,atname*80,dustname(4)*80
      integer iopar,i

c     data
      data rsol /6.9598d10/
      data msol /1.989d33/
      data rmin /1.d0/
      data aflux,flux,sflux /3*0.d0/
      data cflpar /'mctherm.par'/,iopar /11/

c     read in variables

      call reapar(cflpar,iopar,atname,dustname)
c occult not in current documentation
      occult = 1

c     wavelength stuff
      numin=1.2398/5000.    ! lambda = 1000microns
      numax=min(32.*tstar/11605.d0,24.6d0) 
c      numax=1.2398/0.05     ! lambda = 0.05microns
      print*,'wavelength range (microns)',1.2398/numax,1.2398/numin
      nurat=numax/numin
      lnurat=dlog(numax/numin)
      nunorm=nurat**(0.5/nfreq)-nurat**(-0.5/nfreq)

c     convert units from AU to rstar.
      autors=214.94d0/rstar
c     first calculate rmine based on dust sublimation temperature
c     2004/05/13. change definition of rmine, rmind = minimum radius
c     in units of dust destruction radius.  (so you don't have to
c     calculate it each time).
      tsub=1600.d0
c      tsub=300.d0
c      tsub=150.d0
c      rmine2=0.5*(tsub/tstar)**(-2.4d0)
c     empirical fit
c      rmine2=(tsub/tstar)**(-2.085d0)
      rmine2=(tsub/tstar)**(-2.10d0)
      print*,'dust destruction radius ',rmine2
c     including finite source effect (but not limb darkening)
c     optically thin approximation
      rmine1=dsqrt(1.d0/(1.d0-(1.d0-2.d0*(tsub/tstar)**5)**2))
c      print*,'rmine including finite source',rmine1
c     rmine=rmine1
c     if (rmine.lt.1.) rmine=1.
      print*,'dust destruction radius (au) ',rmine2/autors
c      print*,'including finite source effect',rmine1/autors

      if (irminsub.eq.1) then
        rmine=rmine2*rmine
        rmind=rmine2*rmind
	rddust=rmine2*rddust
      endif

      print*,'rmine,rmind,rddust ',rmine,rmind,rddust

      write(12,*) 'dust destruction radius ',rmine2
      write(12,*) 'rmine,rmind,rddust ',rmine
      write(12,*) 'rmax,rmaxd (AU) ',rmax,rmaxd

c      IZMIN=1
      if (IZMIN.eq.1) then
c     calculate scale height based on Tsub at Rsub
         gn=6.6732d-8
         k=1.38e-16
         muc=2.3
         mH=1.67e-24
         rcgs=rmine2*rstar*rsol
         mcgs=massc*msol
         honr=sqrt(k*Tsub/Gn/mcgs*rcgs/muc/mH)
         h=honr*rmine2
         print*,'h on r at Rsub',honr
         print*,'h (rsub) ',h
         zmin=honr*rmine2/rmine2**b
         print*,'h_0 based on h(r_sub)',zmin
         print*,'assumes Tsub=',Tsub,'    beta =',b
      endif

      rmax=rmax*autors
      rmaxd=rmaxd*autors
      rmaxi=rmaxi*autors      !image size
      rchole=rchole*autors
      rc=rc*autors
      zbub1=zbub1*autors
      zbub2=zbub2*autors
c     note: aperture in radius, not diameter
      aperture2(1)=(aperture2(1)*autors)
      aperture2(2)=(aperture2(2)*autors)
      aperture2(3)=(aperture2(3)*autors)
      write(12,*) 'aperture sizes in Rstar',(aperture2(i),i=1,3)
      aperture2(1)=aperture2(1)**2
      aperture2(2)=aperture2(2)**2
      aperture2(3)=aperture2(3)**2
      z01=z01*autors
      z02=z02*autors
c     zflowmin=zflowmin*autors
      npsav=np+npout
      print*,'npsav',npsav
      
c     for now, calculate scattering in old way, h-g
      idust=1
      nelems=6
      
      write(12,*) 'nx,nxhst ',nx,nxhst
      write(12,*) 'nfreq, nmu',nfreq,nmu
c      write(12,*) 'initial envelope inner dust radius, rmine ',rmine
c      write(12,*) 'disk inner radius, rmind ',rmind
c      write(12,*) 'disk inner dust radius, rddust ',rddust
      
c     don't do this anymore, doing all wavelengths
c     call waveset(cwav,cfldust,ctherm,nwav,MXWAV)
	   ! read in from wavein.dat

c     checks
      if (ihole.eq.1.and.istream.eq.1.and.ipoly.eq.1) then
         write(6,*) 'ERROR, cant have both a streamline and'
         write(6,*) 'polynomial hole.  pick one (istream,  ipoly)'
         write(6,*) ' '
         go to 666
      end if
      go to 777
 666  stop
 777  continue

      write(12,*) 'rmax,rmaxd,rmaxi,rmind,zmin,thetmu0'
      write(12,*) rmax,rmaxd,rmaxi,rmind,zmin,thetmu0
      
      pi=4.0d0*datan(1.0d0)
      r2p=2.0d0*pi
      write(6,*) 'pi,r2p',pi,r2p
      thete=r2p*thete/360.d0
      phie=r2p*phie/360.d0
      sinte=dsin(thete)
      coste=dcos(thete)
      sinpe=dsin(phie)
      cospe=dcos(phie)
c      g2=g**2
c      if(g.eq.0.) isot=1
      hit=0.d0
      htot=0.d0

c     limb darkening = 0 for constant, 1 for eddington.
c     make new table if you want something else
      if (limb.eq.1) call table

c     calculate density based on input mass
c     convert r to solar units.

      z1=zmin
c     if you want, input h/r instead of z1
c      z1=rmaxd*z1/rmaxd**b
c      print*,'scale height at rstar ',z1
c      write(12,*) 'scale height at rstar ',z1
      if(rmaxd.gt.0) then
         zmax=z1*rmaxd**b
      else
         zmax=0.d0
      end if



      return
      end
